// AIvan.c
// the AI of Ivan my compainion robot
// top level c program file
// 
// by Les Hall
// started Thu Aug 18, 2016, 3:24 PM
// 



// include header files
#include <stdlib.h>	// utility functions
#include <stdio.h>	// the standard input / output header
#include "AIvan.h"	// Ivan's header file



// declare functions
int wake_up();  // wake Ivan up
int think(int mode, int cycles);  // Ivan thinks like Rodin's "Thinking Man"
int imagine();  // Ivan is daydreaming (dreaming while awake)
void go_to_sleep(FILE *fp, int cycles);  // tell Ivan to go to sleep
void dream();  // Ivan is dreaming
void print_mode(int mode);  // print Ivan's mode to stdout



// the top level function
int main(int argc, char *argv[]) {

	// declare variables
	int cycles = 0;  // number of cycles remaining in Ivan's waking state
	FILE *fp;  // file pointer to Ivan's long term memory
	int mode = off; // Ivan's mode of operation, defined in AIvan.h
	int seed = RAND_MAX/2;  // random number seed


	// seed the random number generator
	srand(seed);
	
	// print Ivan's mode
	print_mode(mode);

	// read in state of mind from disk file
	mode = awake;
	cycles = wake_up(fp);
	
	// print Ivan's mode
	print_mode(mode);

	// select whether Ivan is imagining or not
	mode |= imagine();

	// keep executing loop as long as Ivan's status is awake
	while(cycles > 0) {
		
		// check to see if Ivan has fallen asleep
		cycles = think(mode, cycles);

		// print Ivan's mode
		print_mode(mode);

	}

	// go to sleep Ivan
	mode = asleep;
	go_to_sleep(fp, cycles);
	
	// print Ivan's mode
	print_mode(mode);

	// dream big Ivan, dream big
	mode |= dreaming;
	dream();
	
	// print Ivan's mode
	print_mode(mode);

}



// wake Ivan up
int wake_up(FILE *fp) {

	// declare local variables
	int cycles = 0;  // the number of cycles to execute this waking state

	// print welcome message
	printf("good morning!  \n");

	// read in Ivan's disk file (his long term memory)
	if ((fp = fopen(fileName, fileMode)) == NULL) {  // open file and check for error`
		printf("error opening file");
		cycles = -1;  // don't run any cycles
		return cycles;
	} else {
		fscanf(fp, "%d", &cycles);	
	}

	// return number of cycles allocated to Ivan
	return cycles;

}



// determine if Ivan is exercising his imagination
int imagine() {

	int state = 0;

	if (rand() < (RAND_MAX/2)) {

		state = imagining;

	}

	return state;

}



// do things while awake
int think(int mode, int cycles) {

	// print Ivan's state of mind this cycle
	printf("Ivan is awake (%d).  \n", cycles);

	// return the number of cycles remaining
	return cycles - 1;

}



// tell Ivan to go to sleep
void go_to_sleep(FILE *fp, int cycles) {

	// close Ivan's long term memory
	if (cycles >= 0) {
		fclose(fp);
	}

	// print going to sleep message
	printf("good night!\n");

}



// Ivan dreams at night
void dream() {

	// print Ivan's dream state
	printf("Ivan is dreaming\n");

}



// print Ivan's mode
void print_mode(int mode) {

	// begin with intro text
	printf("Ivan's mode is");

	// select modes with separate conditionals
	if (mode < 0)
		printf(" error");
	if (mode & off)
		printf(" off");
	if (mode & awake)
		printf(" awake");
	if (mode & asleep)
		printf(" asleep");
	if (mode & dreaming)
		printf(" dreaming");
	if (mode & imagining)
		printf(" imagining");

	// end with a newline
	printf("\n");

}



